from OpenGL import GL,GLUT

CHECKPOINT_TO_SHOW = 5

class Checkpoint:
	def __init__(self, position, radius = 1.0):
		self.position = position
		self.radius = radius
	
	def check_proximity(self, point):
		return (self.position - point).Length() <= self.radius
	
	def draw(self, position_in_line):
		if not position_in_line < CHECKPOINT_TO_SHOW:
			return
		
		GL.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA)
		
		GL.glDisable(GL.GL_LIGHTING)
		GL.glEnable(GL.GL_BLEND)
		GL.glDepthMask(0)
		
		opacity = 1.0 - position_in_line/float(CHECKPOINT_TO_SHOW)
		opacity *= 0.15
		if position_in_line == 0:
			GL.glColor4f(0,0,1,opacity) #blue
		else:
			GL.glColor4f(1,0,0,opacity*2) #red
		
		GL.glPushMatrix()
		GL.glTranslatef(*self.position)
		GLUT.glutSolidSphere(self.radius*0.8, 10, 10)
		GLUT.glutSolidSphere(self.radius, 10, 10)
		GL.glPopMatrix()
		
		GL.glEnable(GL.GL_LIGHTING)
		GL.glDisable(GL.GL_BLEND)
		GL.glDepthMask(1)
