import math
from OpenGL import GL,GLU


bgs = None
class BackGroundSphere:
	def __init__(self):
		self.display_list = GL.glGenLists(1)
		GL.glNewList(self.display_list, GL.GL_COMPILE)
		self._draw()
		GL.glEndList()
	
	@staticmethod
	def Get():
		global bgs
		if not bgs: bgs = BackGroundSphere()
		return bgs
	
	def _draw(self):
		GL.glDisable(GL.GL_LIGHTING)
		GL.glDisable(GL.GL_DEPTH_TEST)
		GL.glDisable(GL.GL_TEXTURE_2D)
		GL.glColor3f(1,1,1)
		
		GL.glPointSize(10)
		
		hangle_diff = math.pi*0.2
		for y in range(10):
			hangle = math.pi*2*(y/10.0-0.5)
			s1 = math.sin(hangle)
			c1 = math.cos(hangle)
			s2 = math.sin(hangle+hangle_diff)
			c2 = math.cos(hangle+hangle_diff)
			GL.glBegin(GL.GL_QUAD_STRIP)
			for x in range(10+1):
				rangle = math.pi*2*x/10.0
				GL.glVertex(s1*math.cos(rangle),s1*math.sin(rangle),c1,0.001)
				GL.glVertex(s2*math.cos(rangle),s2*math.sin(rangle),c2,0.001)
			GL.glEnd()
		GL.glEnable(GL.GL_DEPTH_TEST)
	
	def draw(self):
		GL.glCallList(self.display_list)
	
	def __del__(self):
		#GL.glDeleteLists(self.display_list, 1)
		pass
	
def Init3D():
	GL.glDepthMask(1)
	GL.glEnable(GL.GL_DEPTH_TEST)
	GL.glEnable(GL.GL_CULL_FACE)
	GL.glEnable(GL.GL_LIGHTING)
	GL.glEnable(GL.GL_LIGHT0)
	GL.glEnable(GL.GL_LIGHT1)
	GL.glLightfv(GL. GL_LIGHT0, GL.GL_DIFFUSE, (1.0,1.0,1.0,1.0))
	GL.glLightfv(GL. GL_LIGHT1, GL.GL_DIFFUSE, (1.0,1.0,1.0,1.0))
	#GL.glMaterialfv(GL.GL_FRONT_AND_BACK, GL.GL_SPECULAR, (0.0,0.0,10.0,1.0))
	#GL.glMaterialf(GL.GL_FRONT_AND_BACK, GL.GL_SHININESS, 2.35)
	
	GL.glMatrixMode(GL.GL_PROJECTION)
	GL.glLoadIdentity()
	GLU.gluPerspective(45, 1.0, 1, 2000)
	GL.glMatrixMode(GL.GL_MODELVIEW)

def Init2D():
	GL.glDepthMask(0)
	GL.glDisable(GL.GL_DEPTH_TEST)
	
	GL.glTexEnvi(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_REPLACE)
	GL.glEnable(GL.GL_BLEND)
	GL.glEnable(GL.GL_TEXTURE_2D)
	GL.glDisable(GL.GL_LIGHTING)
	GL.glBlendFunc(GL.GL_SRC_ALPHA,GL.GL_ONE_MINUS_SRC_ALPHA)
	GL.glColor4f(1.0,1.0,1.0,1.0)
	
	GL.glMatrixMode(GL.GL_PROJECTION)
	GL.glLoadIdentity()
	GL.glMatrixMode(GL.GL_TEXTURE)
	GL.glLoadIdentity()
	GL.glMatrixMode(GL.GL_MODELVIEW)
	GL.glLoadIdentity()
	
	GL.glScalef(2,-2,1)
	GL.glTranslatef(-0.5,-0.5,0)
	GL.glScalef(1.0/800,1.0/600,1)

def check_point_in_rect(point,rect):
	if point[0] < rect[0] or point[0] > rect[2]:
		return False
	if point[1] < rect[1] or point[1] > rect[3]:
		return False
	return True
