import profile
from level_data import *
import menus
import menuprofile
import main

current_game = None

class Game:
	@staticmethod
	def GetCurrent():
		global current_game
		if not current_game:
			current_game = Game()
			current_game.start()
		return current_game
	
	@staticmethod
	def Destroy():
		global current_game
		del current_game
	
	def __init__(self):
		#load profiles
		self.profiles = profile.LoadProfiles()
		if (self.profiles == None):
			self.profiles = profile.Profiles()
	
	def start(self):
		#
		if len(self.profiles.profiles) == 0:
			self.level = menuprofile.NewProfile()
		elif self.profiles.get_current() == None:
			self.level = menuprofile.SelectProfile()
		else:
			try:
				self.level = data.load_level(int(sys.argv[1]))
			except:
				self.level = menus.MainMenu()
	
	def do_frame(self,TimeDelta):
		self.level.DoStuff(TimeDelta)
		if self.level.NextScreen:
			next = self.level.NextScreen
			del self.level.NextScreen
			if hasattr(self.level,"gui_sprite"):
				del self.level.gui_sprite
			self.level = next
		elif self.level.NextScreen == 0:
			main.end_game = True
	
	def handle_event(self, event):
		self.level.HandleEvent(event)
