import time

import pygame
import ode

from game import Game
import data

def handle_video_expose():
	pass

def handle_event(event):
	global end_game
	
	#pass those events to the game
	Game.GetCurrent().handle_event(event)
	
	if event.type == pygame.VIDEOEXPOSE:
		handle_video_expose()
	
	elif event.type == pygame.QUIT:
		end_game = True

def idle():
	global last_time
	cur_time = time.time()
	TimeDelta = cur_time - last_time
	last_time = cur_time
	
	Game.GetCurrent().do_frame(TimeDelta)
	
	pygame.display.flip()

def main():
	global last_time
	global end_game
	
	pygame.init()
	window = pygame.display.set_mode((800,600),pygame.FULLSCREEN | pygame.HWSURFACE | pygame.DOUBLEBUF | pygame.OPENGL)
	
	Game.GetCurrent()
	last_time = time.time()
	
	end_game = False
	while not end_game:
		events = pygame.event.get()
		for event in events:
			handle_event(event)
		if events == []:
			idle()
	
	Game.Destroy()
	data.CleanUp()
	
	ode.CloseODE()
	pygame.quit()