from OpenGL import GL

class Model:
	def __init__(self, filename):
		lines = file(filename,"r").readlines()
		
		self.display_list = GL.glGenLists(1)
		GL.glNewList(self.display_list, GL.GL_COMPILE)
		GL.glBegin(GL.GL_TRIANGLES)
		
		vertices = []
		normals = []
		for line in lines:
			if line == "":
				continue
			if line[0] == 'v':
				if line[1] == 'n':
					normals.append(map(float,line[2:].strip().split(" ")))
				else:
					vertices.append(map(float,line[1:].strip().split(" ")))
			
			if line[0] == 'f':
				points = line[1:].strip().split(" ")
				for point in points:
					point_data = point.split("/")
					GL.glNormal3d(*normals[int(point_data[2])])
					GL.glVertex3d(*vertices[int(point_data[0])])
		
		GL.glEnd()
		GL.glEndList()
	
	def draw(self):
		GL.glCallList(self.display_list)
	
	def __del__(self):
		GL.glDeleteLists(self.display_list,1)
