import draw
import sprite
import data

class Screen:
	def __init__(self):
		self.NextScreen = None
	
	def Draw3D(self, TimeDelta):
		"Used by self, needs to be implemented by the subclasses"
		pass
	
	def MoveStuff(self,TimeDelta):
		"Used by self, needs to be implemented by the subclasses"
		pass
	
	def Draw2D(self, TimeDelta):
		"Used by self, needs to be implemented by the subclasses"
		pass
	
	def DoStuff(self, TimeDelta):
		"Used by the main game module, doesn't need to be re-implemented"
		#drawing 3d:
		draw.Init3D()
		self.Draw3D(TimeDelta)
		
		#moving
		self.MoveStuff(TimeDelta)
		
		#drawing sprites
		draw.Init2D()
		
		self.Draw2D(TimeDelta)
	
	
	def HandleEvent(self, event):
		"Used by the main game module, may be implemented by the subclasses"
		if False:
			#mouse buttons: 1:Left, 2:Middle, 3:Right, 4:Scroll Up, 5:Scroll Down
			if event.type == pygame.MOUSEMOTION:
				handle_mouse_motion(event.pos, event.rel, event.buttons)
			elif event.type == pygame.MOUSEBUTTONUP:
				handle_mouse_button_up(event.pos, event.button)
			elif event.type == pygame.MOUSEBUTTONDOWN:
				handle_mouse_button_down(event.pos, event.button)
				
			elif event.type == pygame.KEYDOWN:
				handle_key_down(event.unicode, event.key, event.mod)
			elif event.type == pygame.KEYUP:
				handle_key_up(event.key, event.mod)
	
	def __del__(self):
		pass

class GUIScreen(Screen):
	def __init__(self, theme = None):
		Screen.__init__(self)
		
		if not theme:
			theme = data.load_theme("common")
		self.gui_sprite = sprite.GUISprite(800, 600, theme = theme)
	
	def Draw2D(self, TimeDelta):
		self.gui_sprite.draw()
	
	def HandleEvent(self, event):
		self.gui_sprite.handle_event(event)
