
class Vector3(object):
	def __init__(self,x,y,z):
		self.values = map(float,[x,y,z])
	
	def __add__(self, other):
		if type(other) != Vector3:
			other = Vector3(*other)
		return Vector3(*map(float.__add__, self.values, other.values))
	def __sub__(self, other):
		if type(other) != Vector3:
			other = Vector3(*other)
		return Vector3(*map(float.__sub__, self.values, other.values))
	
	def __mul__(self, other):
		return Vector3(*[val*other for val in self.values])
	def __rmul__(self, other):
		return self.__mul__(other)
	
	def Cross(self,other):
		# | x1,  y1,  z1  |
		# | x2, y2, z2  | = (x_res, y_res, z_res)
		# | e1,  e2,  e3 |
		return Vector3(
			self.y*other.z-self.z*other.y,
			self.z*other.x-self.x*other.z,
			self.x*other.y-self.y*other.x)
	
	def Length(self):
		return sum(map(float.__mul__,self.values,self.values)) ** 0.5
	
	def Normalized(self):
		length = self.Length()
		return Vector3(*[val/length for val in self.values])
	
	def __getattr__(self, key):
		if key == "x":
			return self.values[0]
		elif key == "y":
			return self.values[1]
		elif key == "z":
			return self.values[2]
	
	def __setattr__(self, key, value):
		if key == "x":
			self.values[0] = value
		elif key == "y":
			self.values[1] = value
		elif key == "z":
			self.values[2] = value
		elif key == "values":
			object.__setattr__(self,key,value)
	
	def	__getitem__(self, key):
		return self.values[key]
	
	def __iter__(self):
		return self.values.__iter__()
	
	def __str__(self):
		return "Vector3: " + str(self.values)
	
